// ViewOnDlgView.cpp : implementation of the CViewOnDlgView class
//

#include "stdafx.h"
#include "ViewOnDlg.h"

#include "ViewOnDlgDoc.h"
#include "ViewOnDlgView.h"
#include "rInnerView.h"
#include "rInnerDoc.h"
#include "ChildFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewOnDlgView

IMPLEMENT_DYNCREATE(CViewOnDlgView, CFormView)

BEGIN_MESSAGE_MAP(CViewOnDlgView, CFormView)
	//{{AFX_MSG_MAP(CViewOnDlgView)
	ON_BN_CLICKED(IDC_SHOWDLG_BTN, OnShowdlgBtn)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewOnDlgView construction/destruction

CViewOnDlgView::CViewOnDlgView()
	: CFormView(CViewOnDlgView::IDD)
{
	//{{AFX_DATA_INIT(CViewOnDlgView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CViewOnDlgView::~CViewOnDlgView()
{
}

void CViewOnDlgView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewOnDlgView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CViewOnDlgView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CViewOnDlgView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CViewOnDlgView printing

BOOL CViewOnDlgView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CViewOnDlgView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CViewOnDlgView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CViewOnDlgView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CViewOnDlgView diagnostics

#ifdef _DEBUG
void CViewOnDlgView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewOnDlgView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewOnDlgDoc* CViewOnDlgView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewOnDlgDoc)));
	return (CViewOnDlgDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewOnDlgView message handlers

// when you want to show the view
void CViewOnDlgView::OnShowdlgBtn() 
{
	// Add the desired document template
	CDocTemplate* pDocTemplate = NULL;
	pDocTemplate = new CMultiDocTemplate(
		IDR_INNERVIEW,
		RUNTIME_CLASS(CrInnerDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CrInnerView));
	AfxGetApp()->AddDocTemplate(pDocTemplate);
	
	// Create an instance of the desired document template
	CString processName; 
	bool bIsFound = false;

	CWinApp* pApp = AfxGetApp();
	POSITION curTemplatePos = pApp->GetFirstDocTemplatePosition();
	while(curTemplatePos)
	{
		pDocTemplate = pApp->GetNextDocTemplate(curTemplatePos);
		if (pDocTemplate)
		{
			pDocTemplate->GetDocString(processName , CDocTemplate::docName);
			if( processName == "InnerView") 
			{
				bIsFound = true;
				break;
			}
			else
				processName = ""; 
		}
	}
	if (bIsFound)
		pDoc = pDocTemplate->OpenDocumentFile(NULL);

	// send a message to the view to move itself to the dialog
	POSITION pos = pDoc->GetFirstViewPosition();
	while (pos)
	{
		CView* pView = pDoc->GetNextView(pos);
		pView->SendMessage(WM_SHOW_ON_DLG, 0, 0);
	}
}
