// rInnerView.cpp : implementation file
//

#include "stdafx.h"
#include "ViewOnDlg.h"
#include "rInnerView.h"
#include "rPopupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CrInnerView

IMPLEMENT_DYNCREATE(CrInnerView, CFormView)

CrInnerView::CrInnerView()
	: CFormView(CrInnerView::IDD)
{
	//{{AFX_DATA_INIT(CrInnerView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CrInnerView::~CrInnerView()
{
}

void CrInnerView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CrInnerView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CrInnerView, CFormView)
	//{{AFX_MSG_MAP(CrInnerView)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SHOW_ON_DLG, ShowOnDlg)
	ON_MESSAGE(WM_MOUSEACTIVATE, OnMouseActivate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CrInnerView diagnostics

#ifdef _DEBUG
void CrInnerView::AssertValid() const
{
	CFormView::AssertValid();
}

void CrInnerView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CrInnerView message handlers

int CrInnerView::ShowOnDlg(WPARAM wParam, LPARAM lParam)
{
	// hiding the previous parent
	GetParent()->ShowWindow(SW_HIDE);
	
	// creating the bearer dialog
	CrPopupDlg dlg;
	dlg.SetView(this);
	dlg.DoModal();

	return 0;
}

// this method needs to be overridden to prevent an assertion
int CrInnerView::OnMouseActivate( CWnd* pDesktopWnd, UINT nHitTest, UINT message )
{
	return MA_ACTIVATE;
}
