// rPopupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "viewondlg.h"
#include "rPopupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CrPopupDlg dialog


CrPopupDlg::CrPopupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CrPopupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CrPopupDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pView = NULL;
	m_pPrevParent = NULL;
}


void CrPopupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CrPopupDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CrPopupDlg, CDialog)
	//{{AFX_MSG_MAP(CrPopupDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CrPopupDlg message handlers

BOOL CrPopupDlg::OnInitDialog() 
{
	if (m_pView && ::IsWindow(m_pView->m_hWnd))
	{
		// set this as the view's parent and save the old parent
		m_pPrevParent = m_pView->SetParent(this);
		// resize the view to the measures of the dlg
		CRect rect;
		GetClientRect(rect);
		m_pView->MoveWindow(rect);
	}

	return TRUE;
}

void CrPopupDlg::SetView(CView* pView)
{
	// saves a pointer to the view we want to attach to this dlg
	m_pView = pView;
}

void CrPopupDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// set the previous parent window back as active parent and destroy both windows
	if (m_pPrevParent && ::IsWindow(m_pPrevParent->m_hWnd))
	{
		m_pView->SetParent(m_pPrevParent);
		m_pView->GetParent()->DestroyWindow();
	}
}
